# Web GUI

Still work in progress. For now it is still using traditional front-end pages.
Anyone can make contributions by using simple HTML, bootstrap and JS stuff.
[Ros help for JS](http://robotwebtools.org/jsdoc/roslibjs/current/Ros.html).

## Dependancies
- ROSBridge
  ```
  sudo apt-get install ros-<rosdistro>-rosbridge-server
  ```
- DroneOA ROS project

## How to launch
- **Ensure you have at least the following nodes/apps up and running**
  - sim_vehicle - This is the SITL simulation instance of Ardupilot
  - DRONEOA
    - step1* - This launches all dependance nodes for droneoa ros project
    - step2 - This is the main node of droneoa ros project
- **Launch a ROS Bridge on vehicle for the web interface:**
  - `roslaunch ./launch/websocket_ros.launch`
  - You can modify port number in the launch file
- **Launch the web GUI**
  - Option 1: use VSCode
    - Install plugin `Live Server`
    - Open `main.html` page by right click and choose `Open With Live Server`
  - Option 2: setup a local server
    - WIP

## How to use
- Choose ROSBridge port number by editing the `websocket_ros.launch` file on the vehicle
- **Enter you vehicle IP and Port to connect the GUI and ROS.** Default is `0.0.0.0` or `localhost` on port `9090` for typical local test environment
- Once connected. **The connection status should be `connected`.** Refresh the page and check configuration if status is unknown, error or closed
- The **Joystick** can be use to directly maniplate the aircraft.
