# GUI Use Case
Note: UC = Use Case; A = Alternative; E = Exception

<style type="text/css">
	table.tableizer-table {
		font-size: 12px;
		border: 1px solid #CCC; 
		font-family: Arial, Helvetica, sans-serif;
	} 
	.tableizer-table td {
		padding: 4px;
		margin: 3px;
		border: 1px solid #CCC;
	}
	.tableizer-table th {
		background-color: #104E8B; 
		color: #FFF;
		font-weight: bold;
	}
</style>
<table class="tableizer-table">
<thead><tr class="tableizer-firstrow"><th>UC1</th><th>Fly from A to B</th><th>FOR ALL USE CASES THE OA IS ON with full functionalities BY DEFAULT</th><th>&nbsp;</th></tr></thead><tbody>
 <tr><td>ID</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>1</td><td>Operator turn on the GUI</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>2</td><td>&nbsp;</td><td>GUI turned on and display a menu of options</td><td>&nbsp;</td></tr>
 <tr><td>3</td><td>Operator connects the drone in GUI by typing in IP and port</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>4</td><td>&nbsp;</td><td>GUI takes the IP and port and send connect request to drone</td><td>&nbsp;</td></tr>
 <tr><td>5</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack connection</td></tr>
 <tr><td>6</td><td>&nbsp;</td><td>GUI shows connected and status and operations available to operator</td><td>&nbsp;</td></tr>
 <tr><td>7</td><td>Operator set the destnation</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>8</td><td>&nbsp;</td><td>GUI receives the destnation and generates command required</td><td>&nbsp;</td></tr>
 <tr><td>9</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone try to reach the destnation and periodically send self status and coordination</td></tr>
 <tr><td>10</td><td>&nbsp;</td><td>&nbsp;</td><td>If obscales present, try to calculate path to avoid them</td></tr>
 <tr><td>11</td><td>&nbsp;</td><td>GUI shows the status and location of the drone on the GPS map</td><td>&nbsp;</td></tr>
 <tr><td>12</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone reaches the destnation and lands</td></tr>
 <tr><td>13</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack reached</td></tr>
 <tr><td>14</td><td>&nbsp;</td><td>GUI shows the operation is successful</td><td>&nbsp;</td></tr>
 <tr><td>15</td><td>Operator disconnects from the drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A1.1</b></td><td>Operator uses manual control</td><td>Replace step 7 - 8</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>Operator manually controls the plane by using the GUI panel</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI receives the operations step by step and generates command required</td><td>&nbsp;</td></tr>
 <tr><td><b>E1.1</b></td><td>Wrong IP/port</td><td>Replace step 3 - 6</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>Operator input wrong IP/port</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tried to connect with IP/port</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>No response received from drone</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells wrong IP/port and let operator to re-enter</td><td>&nbsp;</td></tr>
 <tr><td><b>A1.2</b></td><td>Obscale present with OA set to collision avoidance only</td><td>Extend step 10</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone detects obscales and stop at a safe distance (instead of calculating path to avoid them)</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack GUI obscale present</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells obscale present, awaiting command</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>THEN FOLLOW A1.1 OR E1.3 OR UC2</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E1.2</b></td><td>The destination is not reachable</td><td>Replace step 12 - 15</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone discover that the destination is not reachable (instead of reaching the destination)</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack failed</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI shows the operation is unsuccessful since the destination is not reachable</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Operator set new destination OR FOLLOW A1.1 OR E1.3 OR UC2</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A1.3</b></td><td>Go to the next destination</td><td>Replace step 15</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>GOTO step 7 OR A1.1 OR A1.4</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E1.3</b></td><td>No input while the drone requires user input</td><td>Any step taken by operator</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>No input (but should input)</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI wait until timeout, then send landing signal to drone</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Land, ack and disarm</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells the drone is landed</td><td>&nbsp;</td></tr>
 <tr><td><b>E1.4</b></td><td>Voltage drop, indicating the power is low</td><td>Any step</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Attempt to RTL and ack low power</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells the power is low and RTL</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Operator retrieve the drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E1.4.1</b></td><td>Sensor detect unsuitable landing area while voltage extremely low</td><td>Extend E1.4</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>GOTO  E4.2</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A1.4</b></td><td>Use joystick</td><td>Replace step 7 - 11</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>Operator uses the joystick to control (instead of setting destination)</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI detects joystick input and turn OA set to collision avoidance only</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI translate the joystick input and generates command required</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone try to reach the destnation and periodically send self status and coordination</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>If obscales present, try to maintain a safe distance between the obscales</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI shows the status and location of the drone on the GPS map</td><td></td></tr>
</tbody></table>

<table class="tableizer-table">
<thead><tr class="tableizer-firstrow"><th>UC2</th><th>Return to land</th><th>Prereq: the drone in this case has taken off already</th><th>&nbsp;</th></tr></thead><tbody>
 <tr><td>ID</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>1</td><td>At any time, the operator select Return To Land from the GUI</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>2</td><td>&nbsp;</td><td>GUI send Return to Land command to drone</td><td>&nbsp;</td></tr>
 <tr><td>3</td><td>&nbsp;</td><td>&nbsp;</td><td>Drive to the point where it take off, then land</td></tr>
 <tr><td>4</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack reached</td></tr>
 <tr><td>5</td><td>&nbsp;</td><td>GUI tells the Return to Land is successful.</td><td>&nbsp;</td></tr>
 <tr><td>6</td><td>Operator disconnects from the drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A2.1</b></td><td>Go to the next destination</td><td>Replace step 6</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>GOTO UC1 step 7 OR A1.3</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E2.1</b></td><td>Voltage drop, indicating the power is low</td><td>Any step</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>SAME AS E1.4</td><td>&nbsp;</td><td></td></tr>
</tbody></table>

<table class="tableizer-table">
<thead><tr class="tableizer-firstrow"><th>UC3</th><th>Fly using command queue</th><th>Note: has an additional layer of command queue.</th><th>&nbsp;</th><th>&nbsp;</th></tr></thead><tbody>
 <tr><td>1</td><td>Drone Operator</td><td>GUI</td><td>Command  Parser</td><td>Drone</td></tr>
 <tr><td>2</td><td>Operator turn on the GUI</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>3</td><td>&nbsp;</td><td>GUI turned on and display a menu of options</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>4</td><td>Operator connects the drone in GUI</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>5</td><td>&nbsp;</td><td>GUI takes the IP and port and send connect request to drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>6</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack connection</td></tr>
 <tr><td>7</td><td>&nbsp;</td><td>GUI shows connected and status and operations available to operator</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>8</td><td>Operator type a command queue into Command Queue field</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>9</td><td>&nbsp;</td><td>GUI receives the command queue and send it to Console Manager</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>10</td><td>&nbsp;</td><td>&nbsp;</td><td>Parse the command queue and generate a sequence of commands (see cmd queue use cases)</td><td>&nbsp;</td></tr>
 <tr><td>11</td><td>&nbsp;</td><td>&nbsp;</td><td>Send commands to the drone in order</td><td>&nbsp;</td></tr>
 <tr><td>12</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone try to execute the commands and periodically send self status and coordination</td></tr>
 <tr><td>13</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>If obscales present, try to calculate path to avoid them</td></tr>
 <tr><td>14</td><td>&nbsp;</td><td>GUI shows the status and the location of the drone on the GPS map</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>15</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone finished executing commands</td></tr>
 <tr><td>16</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack executed</td></tr>
 <tr><td>17</td><td>&nbsp;</td><td>GUI shows the operation is successful</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>18</td><td>Operator disconnects from the drone</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A3.1</b></td><td>Obscale present with OA set to collision avoidance only</td><td>Extend step 13</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Command  Parser</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone detects obscales and stop at a safe distance (instead of calculating path to avoid them)</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack GUI obscale present and execution status</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells obscale present and the execution of the command queue is aborted at specific location, awaiting input</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Operator set new command queue / new destination / A1.1 / A1.4 / E1.3 / UC2</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E3.1</b></td><td>A waypoint is not reachable</td><td>Replace step 15 - 18</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Command  Parser</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone discover that the destination is not reachable (instead of reaching the destination)</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack GUI failed and execution status</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI shows the operation is unsuccessful since the waypoint is not reachable</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Operator set new command queue / new destination / A1.1 / A1.4 / E1.3 / UC2</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A3.2</b></td><td>Go to the next destination</td><td>Replace step 18</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>GOTO step 8 OR A1.3</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E3.2</b></td><td>No input while the drone requires user input</td><td>Any step taken by operator</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>SAME AS E1.3</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E3.3</b></td><td>Voltage drop, indicating the power is low</td><td>Any step</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>SAME AS E1.4</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E3.3.1</b></td><td>Sensor detect unsuitable landing area while voltage extremely low</td><td>Extend E3.3</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>SAME AS E1.4.1</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E3.4</b></td><td>Wrong IP/port</td><td>Replace step 5 - 6</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Command  Parser</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>Operator input wrong IP/port</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tried to connect with IP/port</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>No response received from drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells wrong IP/port and let operator to re-enter</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E3.5</b></td><td>Command queue error</td><td>Replace steps 10 - 18</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Command  Parser</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Parse the command queue and fails (see cmd queue use cases and exceptions)</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Console Manager ack parsing failed</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells invalid command queue</td><td>                                                                                                                                                                                                                           </td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Operator re-enter the command queue</td><td>&nbsp;</td><td>&nbsp;</td><td></td></tr>
</tbody></table>

<table class="tableizer-table">
<thead><tr class="tableizer-firstrow"><th>UC4</th><th>Land immediate</th><th>Prereq: the drone in this case has taken off already</th><th>&nbsp;</th></tr></thead><tbody>
 <tr><td>ID</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>1</td><td>At any time, the operator select Land from the GUI</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>2</td><td>&nbsp;</td><td>GUI send Land command to drone</td><td>&nbsp;</td></tr>
 <tr><td>3</td><td>&nbsp;</td><td>&nbsp;</td><td>Attempt to land immediately</td></tr>
 <tr><td>4</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack landed</td></tr>
 <tr><td>5</td><td>&nbsp;</td><td>GUI tells the Land is successful.</td><td>&nbsp;</td></tr>
 <tr><td>6</td><td>Operator disconnects from the drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A4.1</b></td><td>Go to the next destination</td><td>Replace step 6</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>GOTO UC1 step 7 or UC3 step 8</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E4.1</b></td><td>Sensor detect unsuitable landing area</td><td>Replace step 4-6</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Maintain a safe altitude and ack not land-able (instead of landing)</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells the Land failed</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Operator adjust the position of drone and attempt to land again</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E4.2</b></td><td>Sensor detect unsuitable landing area and extreme low power</td><td>Replace step 1-6</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI acks the power is extreme low and disable menus and user inputs</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Force land immediately</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drrone ack force landed</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells the force landing complete, motor disengage</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Operator retrieve the drone</td><td>&nbsp;</td><td></td></tr>
</tbody></table>

<table class="tableizer-table">
<thead><tr class="tableizer-firstrow"><th>UC5</th><th>Manage Plugins</th><th>&nbsp;</th><th>&nbsp;</th><th>&nbsp;</th></tr></thead><tbody>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Plugin manager</td><td>Drone</td></tr>
 <tr><td>1</td><td>Operator turn on the GUI</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>2</td><td>&nbsp;</td><td>GUI turned on and display a menu of options</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>3</td><td>Operator connects the drone in GUI</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>4</td><td>&nbsp;</td><td>GUI takes the IP and port and send connect request to drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>5</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Drone ack connection</td></tr>
 <tr><td>6</td><td>&nbsp;</td><td>GUI shows connected and status and operations available to operator</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>7</td><td>Operator click on Plugins</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>8</td><td>&nbsp;</td><td>GUI shows installed plugins and a plugin store</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>9</td><td>Operator remove installed plugins / install plugins from the store</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>10</td><td>&nbsp;</td><td>GUI send commands to plugin manager accordingly</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>11</td><td>&nbsp;</td><td>&nbsp;</td><td>Verify the avability of the package</td><td>&nbsp;</td></tr>
 <tr><td>12</td><td>&nbsp;</td><td>&nbsp;</td><td>Execute the command</td><td>&nbsp;</td></tr>
 <tr><td>13</td><td>&nbsp;</td><td>&nbsp;</td><td>Plugin manager ack successful</td><td>&nbsp;</td></tr>
 <tr><td>14</td><td>&nbsp;</td><td>GUI tells the user the operation is successful</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>15</td><td>Operator disconnects from the drone</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A5.1</b></td><td>Operator install local package</td><td>Replace step 9</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Plugin manager</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>Operator install plugin from local storage (instead of uninstall / install online)</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E5.1</b></td><td>Verification failed (plugin in use / broken package</td><td>Replace step 12 - 14</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Plugin manager</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Plugin manager ack failed</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells the user the operation failed</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>A5.2</b></td><td>Operator decided to fly the drone</td><td>Replace step 15</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>GOTO A3.2 OR A1.3</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td><b>E5.2</b></td><td>Wrong IP/port</td><td>Replace step 5 - 6</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>Drone Operator</td><td>GUI</td><td>Plugin manager</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>Operator input wrong IP/port</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tried to connect with IP/port</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>No response received from drone</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>GUI tells wrong IP/port and let operator to re-enter</td><td>&nbsp;</td><td></td></tr>
</tbody></table>
