# Current Hardware Support

## Test Platform:
- [OA450](https://gitlab.tuotuogzs.com/droneoa/droneoa_ros/wikis/Test-Vehicle-OA450)
- OA650 (WIP Delayed due to local policy)

## Supported Flight Controller Unit (FCU):
- [Ardupilot](https://ardupilot.org/)
- [PX4](https://px4.io/) (WIP)
- Most [Mavlink](https://mavlink.io/) based FCU

## Supported Sensors:
- Lidar:
    - [YDLidar](https://www.ydlidar.com/) X2L
    - [RPLidar](https://www.slamtec.com/en/Lidar/A1) Lineup (WIP)
- Depth Camera:
    - [Realsense](https://www.intelrealsense.com/) D435(i) local only
    - [Realsense](https://www.intelrealsense.com/) D435(i) + T265 local/global
    - [ZED](https://www.stereolabs.com/zed/) camera (WIP)
- Normal Camera (Planned)

## Supported Other Equipment:
- Community works Coming soon.

## Supported Onboard Computer (OBC)s:
- [Jetson nano](https://developer.nvidia.com/embedded/jetson-nano-developer-kit)
- [Raspberry Pi 4](https://www.raspberrypi.org/products/raspberry-pi-4-model-b/)
- [Up board](https://up-shop.org/) 1st gen
- Most other x86 systems with at least 2 USB/serial ports
- More to be added
