# Tips And Tricks

## Develop With VSCode
Steps:
- Install plugin `ROS` and `C/C++` in VSCode extensions
- Build the ros workspace with `catkin_make -DCMAKE_EXPORT_COMPILE_COMMANDS=Yes`

## Package not found when try to roslaunch
source `setup.bash` or `setup.zsh` depends on the user's terminal preference
```
source <WORKSPACE_PATH>/devel/setup.bash
```
The developer can also add this to the end of `~/.bashrc`

## How to check `haros` static analyze report?
1. Navigate to the pipeline page with the user's pipeline ID.
2. Click the job called `haros` in stage `StaticAnalysis`.

   ![Pipeline Page](Pic/pipelinePage.PNG)

3. Download the artifacts use the `Download` button located at the right edge of the page.

   ![Download artifacts](Pic/harosDownload.PNG)

4. Unzip the artifacts package.
5. In report folder, open `index.html` with:
    - Option1: `Microsoft Edge`. (Note: only Edge is tested working directly)
    - Option2: In `VSCode`, install plugin `Live Server`, then right click `index.html` and select `Open With Live Server`
6. View issues in issues tab.
